﻿using Remora.Discord.API;
using Remora.Discord.API.Abstractions.Objects;
using Remora.Discord.Extensions.Embeds;

namespace Cassette.Extensions;

public static class EmbedBuilderExtensions
{
    public static EmbedBuilder WithUserAuthor(
        this EmbedBuilder builder, string name, IUser? user, string? url = null)
    {
        if (user is null)
        {
            return builder.WithAuthor(name, url);
        }

        var iconResult = CDN.GetUserAvatarUrl(user);
        return builder.WithAuthor(name, url, !iconResult.IsDefined(out var iconUri)
            ? CDN.GetDefaultUserAvatarUrl(user).Entity.AbsoluteUri
            : iconUri.AbsoluteUri);
    }
}
